"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toPromise = exports.toCallback = void 0;
var _highland = _interopRequireDefault(require("highland"));
var _bluebird = _interopRequireDefault(require("bluebird"));
var _opt = require("./opt");
const toCallback = cb => s => s.consume((err, x, push, next) => {
  if (err) {
    cb(err);
  } else if (x === _highland.default.nil) {
    cb(null, 'Success');
  } else {
    next();
  }
}).resume();
exports.toCallback = toCallback;
const toPromise = s => {
  const opt = (0, _opt.options)();
  if (opt.metrics) {
    return opt.metrics.toPromise(opt, s);
  } else {
    return new _bluebird.default((resolve, reject) => {
      s.consume((err, x, push, next) => {
        if (err) {
          reject(err);
        } else if (x === _highland.default.nil) {
          resolve('Success');
        } else {
          next();
        }
      }).resume();
    });
  }
};
exports.toPromise = toPromise;